"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var transformLayoutStyleProperties_1 = require("../../styleTransformers/transformLayoutStyleProperties");
var transformGeometryStyleProperties_1 = require("../../styleTransformers/transformGeometryStyleProperties");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
var useFillsPreprocessor_1 = require("../../hooks/useFillsPreprocessor");
var transformBorderProperties_1 = require("../../styleTransformers/transformBorderProperties");
var transformBlendProperties_1 = require("../../styleTransformers/transformBlendProperties");
exports.Rectangle = function (props) {
    var yogaRef = React.useRef();
    var rectangleProps = __assign(__assign(__assign(__assign(__assign({}, transformLayoutStyleProperties_1.transformLayoutStyleProperties(props.style)), transformGeometryStyleProperties_1.transformGeometryStyleProperties(props.style)), transformBorderProperties_1.transformBorderStyleProperties(props.style)), transformBlendProperties_1.transformBlendProperties(props.style)), props);
    var fills = useFillsPreprocessor_1.useFillsPreprocessor(rectangleProps);
    var yogaProps = useYogaLayout_1.useYogaLayout(__assign({ yogaRef: yogaRef }, rectangleProps));
    // @ts-ignore
    return React.createElement("rectangle", __assign({}, rectangleProps, yogaProps, (fills && { fills: fills }), { innerRef: yogaRef }));
};
//# sourceMappingURL=Rectangle.js.map