"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var renderers = require("./renderers");
// todo replace with webpack aliasing, install @types/react-reconciler
var createReconciler = require("./realm-adopted/react-reconciler");
var groupsProcessor_1 = require("./renderers/group/groupsProcessor");
var pregroupNode_1 = require("./renderers/group/pregroupNode");
var isReactFigmaNode = function (child) { return child.getPluginData && child.getPluginData('isReactFigmaNode'); };
var appendToContainerFactory = function (groupsProcessor) { return function (parentNode, childNode) {
    if (!childNode || !parentNode) {
        return;
    }
    if (childNode.type === pregroupNode_1.PREGROUP_NODE_TYPE) {
        if (childNode.groupNode) {
            parentNode.appendChild(childNode.groupNode);
        }
        else {
            groupsProcessor.scheduleGroup(parentNode, childNode);
        }
    }
    else {
        parentNode.appendChild(childNode);
    }
}; };
var insertToContainer = function (parentNode, newChildNode, beforeChildNode) {
    if (!parentNode || !newChildNode || !beforeChildNode) {
        return;
    }
    var beforeChildIndex = parentNode.children.indexOf(beforeChildNode);
    parentNode.insertChild(beforeChildIndex, newChildNode);
};
var remove = function (childNode) {
    if (!childNode || childNode.removed) {
        return;
    }
    childNode.remove();
};
var renderInstance = function (type, node, props) {
    var instance = renderers[type](node)(props);
    if (!node) {
        instance.setPluginData('isReactFigmaNode', 'true');
    }
    return instance;
};
var getFirstChild = function (parentInstance) {
    if (parentInstance.children && parentInstance.children.length > 0) {
        return parentInstance.children.find(isReactFigmaNode);
    }
};
var getNextChildren = function (instance) {
    if (!instance || !instance.parent) {
        return;
    }
    var parent = instance.parent;
    console.log('getNextHydratableSibling:children', parent.children);
    var instanceIndex = parent.children.indexOf(instance);
    console.log('getNextHydratableSibling:instanceIndex', instanceIndex);
    return parent.children.slice(instanceIndex + 1).find(isReactFigmaNode);
};
exports.render = function (jsx, rootNode) { return __awaiter(void 0, void 0, void 0, function () {
    var groupsProcessor, appendToContainer, HostConfig, reconciler, container, lastPage, tempPage;
    return __generator(this, function (_a) {
        groupsProcessor = new groupsProcessor_1.GroupsProcessor();
        appendToContainer = appendToContainerFactory(groupsProcessor);
        HostConfig = {
            now: Date.now,
            getRootHostContext: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['getRootHostContext'], args));
                return true;
            },
            prepareForCommit: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['prepareForCommit'], args));
            },
            resetAfterCommit: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['resetAfterCommit'], args));
            },
            getChildHostContext: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['getChildHostContext'], args));
                return true;
            },
            shouldSetTextContent: function () { return false; },
            getPublicInstance: function (instance) {
                console.log('getPublicInstance', instance);
                return instance;
            },
            createInstance: function (type, props) {
                var other = [];
                for (var _i = 2; _i < arguments.length; _i++) {
                    other[_i - 2] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['createInstance', type, props], other));
                return renderInstance(type, null, props);
            },
            createTextInstance: function (text) {
                console.log('createTextInstance', text);
            },
            resetTextContent: function (node) {
                console.log('resetTextContent', node);
            },
            // Append root node to a container
            appendInitialChild: function (parentNode, childNode) {
                console.log('appendInitialChild', parentNode, childNode);
                appendToContainer(parentNode, childNode);
            },
            appendChild: function (parentNode, childNode) {
                console.log('appendChild', parentNode, childNode);
                appendToContainer(parentNode, childNode);
            },
            insertBefore: function (parentNode, newChildNode, beforeChildNode) {
                console.log('insertBefore', parentNode, newChildNode, beforeChildNode);
                insertToContainer(parentNode, newChildNode, beforeChildNode);
            },
            finalizeInitialChildren: function (element, type) {
                var args = [];
                for (var _i = 2; _i < arguments.length; _i++) {
                    args[_i - 2] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['finalizeInitialChildren', type], args));
                return type === 'page';
            },
            supportsMutation: true,
            supportsHydration: true,
            appendChildToContainer: function (parentNode, childNode) {
                console.log('appendChildToContainer', parentNode, childNode);
                appendToContainer(parentNode, childNode);
            },
            insertInContainerBefore: function (parentNode, newChildNode, beforeChildNode) {
                console.log('insertInContainerBefore', parentNode, newChildNode, beforeChildNode);
            },
            removeChildFromContainer: function (parentNode, childNode) {
                console.log('removeChildFromContainer', parentNode, childNode);
            },
            prepareUpdate: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['prepareUpdate'], args));
                return true;
            },
            commitUpdate: function (node, updatePayload, type, oldProps, newProps) {
                renderInstance(type, node, newProps);
                console.log('commitUpdate', node, updatePayload, type, oldProps, newProps);
            },
            commitTextUpdate: function (node, oldText, newText) {
                console.log('commitTextUpdate', node, oldText, newText);
            },
            removeChild: function (parentNode, childNode) {
                console.log('removeChild', parentNode, childNode);
                remove(childNode);
            },
            canHydrateInstance: function (instance, type, props) {
                console.log('canHydrateInstance', instance, type, props);
                if (!isReactFigmaNode(instance) || instance.type.toLowerCase() !== type) {
                    return null;
                }
                return instance;
            },
            hydrateInstance: function (instance, type, props) {
                console.log('hydrateInstance', instance, type, props);
                return renderInstance(type, instance.type.toLowerCase() === type ? instance : null, props);
            },
            getFirstHydratableChild: function (parentInstance) {
                console.log('getFirstHydratableChild', parentInstance);
                return getFirstChild(parentInstance);
            },
            getNextHydratableSibling: function (instance) {
                console.log('getNextHydratableSibling', instance);
                return getNextChildren(instance);
            },
            didNotHydrateContainerInstance: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['didNotHydrateContainerInstance'], args));
            },
            didNotFindHydratableContainerInstance: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['didNotFindHydratableContainerInstance'], args));
            },
            didNotFindHydratableInstance: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spreadArrays(['didNotFindHydratableInstance'], args));
            },
            didNotFindHydratableTextInstance: function (parentType, parentProps, parentInstance, text) {
                console.log('didNotFindHydratableTextInstance', parentType, parentProps, parentInstance, text);
            },
            didNotHydrateInstance: function (parentType, parentProps, parentInstance, instance) {
                console.log('didNotHydrateInstance', parentType, parentProps, parentInstance, instance);
            },
            commitMount: function (instance, type, newProps, internalInstanceHandle) {
                console.log('commitMount', instance, type, newProps, internalInstanceHandle);
                if (type === 'page') {
                    groupsProcessor.mountGroups();
                }
            }
        };
        reconciler = createReconciler(HostConfig);
        container = reconciler.createContainer(rootNode, true, true);
        lastPage = figma.currentPage;
        tempPage = figma.createPage();
        figma.currentPage = tempPage;
        reconciler.updateContainer(jsx, container);
        figma.currentPage = lastPage;
        tempPage.remove();
        return [2 /*return*/];
    });
}); };
//# sourceMappingURL=renderer.js.map