"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var layoutMixin_1 = require("../../mixins/layoutMixin");
var refMixin_1 = require("../../mixins/refMixin");
var saveStyleMixin_1 = require("../../mixins/saveStyleMixin");
var baseNodeMixin_1 = require("../../mixins/baseNodeMixin");
var exportMixin_1 = require("../../mixins/exportMixin");
var blendMixin_1 = require("../../mixins/blendMixin");
var pregroupNode_1 = require("./pregroupNode");
exports.group = function (node) { return function (props) {
    var newNode;
    var didMountHandler = function () {
        refMixin_1.refMixin(newNode.figmaNode)(props);
    };
    if (node && node.type === 'GROUP') {
        // If the existing group node is passed
        // it means that it's the hydration case
        // and we should create PregroupNode from existing group
        newNode = pregroupNode_1.PregroupNode.createFromGroupNode(node, didMountHandler);
    }
    else {
        newNode = node || new pregroupNode_1.PregroupNode(didMountHandler);
    }
    if (newNode.figmaNode) {
        var groupNode = newNode.figmaNode;
        saveStyleMixin_1.saveStyleMixin(groupNode)(props);
        baseNodeMixin_1.baseNodeMixin(groupNode)(props);
        layoutMixin_1.layoutMixin(groupNode)(props);
        exportMixin_1.exportMixin(groupNode)(props);
        blendMixin_1.blendMixin(groupNode)(props);
    }
    return newNode;
}; };
//# sourceMappingURL=group.js.map