"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transformSize = function (size) {
    if (typeof size === 'number') {
        return size;
    }
    return parseInt(size);
};
exports.transformBorderStyleProperties = function (styles) {
    if (!styles) {
        return {};
    }
    var border = {};
    if (styles.borderRadius) {
        border.topLeftRadius = transformSize(styles.borderRadius);
        border.topRightRadius = transformSize(styles.borderRadius);
        border.bottomLeftRadius = transformSize(styles.borderRadius);
        border.bottomRightRadius = transformSize(styles.borderRadius);
    }
    if (styles.borderTopLeftRadius) {
        border.topLeftRadius = transformSize(styles.borderTopLeftRadius);
    }
    if (styles.borderTopRightRadius) {
        border.topLeftRadius = transformSize(styles.borderTopRightRadius);
    }
    if (styles.borderBottomLeftRadius) {
        border.topLeftRadius = transformSize(styles.borderBottomLeftRadius);
    }
    if (styles.borderBottomRightRadius) {
        border.topLeftRadius = transformSize(styles.borderBottomRightRadius);
    }
    return border;
};
//# sourceMappingURL=transformBorderProperties.js.map