"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = require("../helpers/color");
var backgroundSizeToScaleMode = {
    cover: 'FILL',
    contain: 'FIT'
};
exports.transformGeometryStyleProperties = function (style) {
    if (!style) {
        return {};
    }
    var fills = [];
    if (style && style.backgroundColor) {
        fills.push({ type: 'SOLID', color: color_1.colorToRGB(style.backgroundColor) });
    }
    if (style && style.backgroundImage) {
        fills.push({
            type: 'IMAGE',
            image: style.backgroundImage,
            scaleMode: style.backgroundSize && backgroundSizeToScaleMode[style.backgroundSize]
        });
    }
    return __assign({}, ((fills.length > 0 && { fills: fills }) || {}));
};
//# sourceMappingURL=transformGeometryStyleProperties.js.map